SystemOrganization addCategory: #'CS528-UT3Base'!

TestCase subclass: #UT3BoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

UT3BoardTest subclass: #UT3BasicBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 11:55'!
testCreateEmptyBoard
	|board|
	board := UT3BasicBoard new.
	self assert: board isFull equals: false.
	self assert: board winner equals: #undecided.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 12:56'!
testPlayOneGameWithColumnWinner
	|board|
	board := UT3BasicBoard new.
	board atRow: 1 column: 1 put: #circle.
	board atRow: 1 column: 2 put: #cross.
	board atRow: 2 column: 1 put: #circle.
	board atRow: 2 column: 2 put: #cross.
	board atRow: 3 column: 3 put: #circle.
	board atRow: 3 column: 2 put: #cross.
	self assert: board movesCount equals: 6.
	self assert: board winner equals: #cross.
	"Cannot change the winner once it's set!!"
	board atRow: 3 column: 1 put: #circle.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 12:56'!
testPlayOneGameWithDiagonalWinner
	|board|
	board := UT3BasicBoard new.
	board atRow: 1 column: 1 put: #cross.
	board atRow: 2 column: 1 put: #circle.
	board atRow: 2 column: 2 put: #cross.
	board atRow: 3 column: 1 put: #circle.
	board atRow: 3 column: 3 put: #cross.
	self assert: board movesCount equals: 5.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 12:56'!
testPlayOneGameWithRowWinner
	|board|
	board := UT3BasicBoard new.
	board atRow: 1 column: 1 put: #cross.
	board atRow: 1 column: 2 put: #circle.
	board atRow: 2 column: 1 put: #cross.
	board atRow: 1 column: 3 put: #circle.
	board atRow: 3 column: 1 put: #cross.
	self assert: board movesCount equals: 5.
	self assert: board winner equals: #cross.! !

!UT3BasicBoardTest methodsFor: 'tests' stamp: 'ShineLow 7/4/2013 20:50'!
testWinnerChecks
	|board|
	"Win by row"
	1 to: 3 do: [ :column | 
		board := UT3BasicBoard new.
		board atRow: 1 column: column put: #cross.
		board atRow: 2 column: column put: #cross.
		board atRow: 3 column: column put: #cross.
		self assert: board movesCount equals: 3.
		self assert: board winner equals: #cross.
	].
	Transcript show: board printString.
	
	"Win by column"
	1 to: 3 do: [ :row | 
		board := UT3BasicBoard new.
		board atRow: row column: 1 put: #circle.
		board atRow: row column: 2 put: #circle.
		board atRow: row column: 3 put: #circle.
		self assert: board movesCount equals: 3.
		self assert: board winner equals: #circle.
	].
	Transcript show: board printString.

	"Win by top left to bottom right diagonal"
	board := UT3BasicBoard new.
	1 to: 3 do: [ :index | board atRow: index column: index put: #cross].
	self assert: board movesCount equals: 3.
	self assert: board winner equals: #cross.
		Transcript show: board printString.

	board := UT3BasicBoard new.
		1 to: 3 do: [ :index | board atRow: index column: ( 3 - index + 1 ) put: #circle].
	self assert: board movesCount equals: 3.
	self assert: board winner equals: #circle.
		Transcript show: board printString.
! !

UT3BoardTest subclass: #UT3NestedBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:16'!
testColumnVictories
	|board|
	board := UT3NestedBoard new.
	( 1 to: board size ) do: [ :row |
		(1 to: board size) do: [ :subRow |
			board at: { row. 1 } subBoard: { subRow. 1 } put: #circle
			 ]
		 ].
	self assert: board winner equals: #circle! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:23'!
testDiagonalVictories
	|board boardSize |
	"Top left to bottom right"
	board := UT3NestedBoard new.
	boardSize := board size.
	( 1 to: boardSize ) do: [ :row |
		(1 to: boardSize) do: [ :subRow |
			board at: { row. row } subBoard: { subRow. subRow } put: #circle
			 ]
		 ].
	self assert: board winner equals: #circle.
	Transcript open; show: board printBoardString .
	
	"Bottom left to top right"
	board := UT3NestedBoard new.
	boardSize := board size.
	( 1 to: boardSize ) do: [ :row |
		(1 to: boardSize) do: [ :subRow |
			board at: { row. boardSize - row + 1 } subBoard: { subRow. boardSize - subRow + 1 } put: #cross
			 ]
		 ].
	self assert: board winner equals: #cross.
	Transcript open; show: board printBoardString ! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 18:14'!
testOneGameRound
	| board |
	"End game result will look like
    |    |     ||     |    | x  ||  x | 0 |    
    | x |     ||     | x |     ||     |    | x 
    |    | 0  ||     |    |     ||     |    |    

    |    |     ||  0 | 0 | 0  ||     |    | 0 
 0 | 0 | 0  ||  x | x | x  ||  x | 0 |    
    |    |     ||     |    |     ||  0 |    |    

    |    |     ||     |    |     ||     |    |    
 x |    |     ||     |    |     ||     |    | x 
    |    |     ||     |    |     ||     |    |    

	Where the winner is Circle"
	board := UT3NestedBoard new.
	board at: { 2. 2 } subBoard: { 2. 2 } put: #cross.
	board at: { 2. 2 } subBoard: { 1. 2 } put: #circle.
	board at: { 1. 2 } subBoard: { 1. 3 } put: #cross.
	board at: { 1. 3 } subBoard: { 1. 2 } put: #circle.
	board at: { 1. 2 } subBoard: { 2. 2 } put: #cross.
	board at: { 2. 2 } subBoard: { 1. 1 } put: #circle.
	board at: { 1. 1 } subBoard: { 2. 2 } put: #cross.
	board at: { 2. 2 } subBoard: { 1. 3 } put: #circle.
	"Middle is won by circle"
	self assert: board winner equals: #undecided.
	board at: { 1. 3 } subBoard: { 2. 3 } put: #cross.
	board at: { 2. 3 } subBoard: { 2. 2 } put: #circle.
	board at: { 2. 2 } subBoard: { 2. 3 } put: #cross.
	board at: { 2. 3 } subBoard: { 1. 3 } put: #circle.
	board at: { 1. 3 } subBoard: { 1. 1 } put: #cross.
	board at: { 1. 1 } subBoard: { 3. 3 } put: #circle.
	board at: { 3. 3 } subBoard: { 2. 3 } put: #cross.
	board at: { 2. 3 } subBoard: { 3. 1 } put: #circle.
	"Middle right won by circle"
	self assert: board winner equals: #undecided.
	board at: { 3. 1 } subBoard: { 2. 1 } put: #cross.
	board at: { 2. 1 } subBoard: { 2. 2 } put: #circle.
	board at: { 2. 2 } subBoard: { 2. 1 } put: #cross.
	board at: { 2. 1 } subBoard: { 2. 3 } put: #circle.
	board at: { 2. 3 } subBoard: { 2. 1 } put: #cross.
	board at: { 2. 1 } subBoard: { 2. 1 } put: #circle.
	self assert: board winner equals: #circle.
	Transcript open; show: board.! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:07'!
testPrintBoardString
	| board1  |
	board1 := UT3NestedBoard new.
	board1 player: 1 moveRow: 1 moveCol: 1.
	board1 player: 2 moveRow: 4 moveCol: 4.
	board1 player: 1 moveRow: 6 moveCol: 5.
	board1 player: 2 moveRow: 5 moveCol: 6.
	board1 player: 1 moveRow: 5 moveCol: 2.
	board1 player: 2 moveRow: 2 moveCol: 8.
	Transcript open; show: board1 printBoardString.! !

!UT3NestedBoardTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:16'!
testRowVictories
	|board|
	board := UT3NestedBoard new.
	( 1 to: board size ) do: [ :column |
		(1 to: board size) do: [ :subColumn |
			board at: { 1. column } subBoard: { 1. subColumn } put: #cross
			 ]
		 ].
	self assert: board winner equals: #cross! !

TestCase subclass: #UT3SystemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 19:12'!
testInitializeBasic
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system player: 1 moveRow: 1 column: 1.
	self assert: system currentPlayer equals: 2.! !

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 01:45'!
testInitializeBasicWithAI
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system resetWithGameType: #basic ai: #random.	
	system player: 1 moveRow: 1 column: 1.
	"After move, the AI will move immediately."
	self assert: system currentPlayer equals: 1.! !

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 19:13'!
testInitializeUltimate
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system resetWithGameType: #ultimate.
	system player: 1 moveAt: { 1. 1 } subBoard: { 1. 1 }.
	self assert: system currentPlayer equals: 2.! !

!UT3SystemTest methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/8/2013 01:52'!
testInitializeUltimateWithAI
	|system|
	system := UT3System new.
	self assert: system currentGameType equals: #basic.
	system resetWithGameType: #ultimate ai: #random.	
	system player: 1 moveAt: { 1. 1 } subBoard: { 1. 1 }.
	self assert: system currentPlayer equals: 1.! !

Error subclass: #MoveError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!MoveError commentStamp: '<historical>' prior: 0!
A MoveError is an Error that is throw when an invalid move happens.

Instance Variables
!

Error subclass: #SystemError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!SystemError commentStamp: '<historical>' prior: 0!
A SystemError is an Error encountered within the System.

Instance Variables
!

Object subclass: #UT3Board
	instanceVariableNames: 'size movesCount winner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Board commentStamp: '<historical>' prior: 0!
An UT3Board is a board.

Instance Variables

Here are a few quick reason about why I code them that way and 

what are those magic numbers stand for.

First, the board(boardMatrix in the code) is a 9 * 9 matrix they actually don't need to be nested(although they could) because we could access it really convenient by rows and columns and we could submatrix whenever we want. 
(here is a handy list of matrix functions http://magaloma.seasidehosting.st/Collections-Unordered)

Each cell in the board, say 1 out of 81, has three status: 

0: not played yet. 
1: player 1 marked. 
2: player 2 taken. 

That boardGlobalMatrix is 3 * 3 and design to mark the winning status of the small board, 
it changes and only changes when one (of the two players) win a subarea.   
It is a global marker with global winning status overview... so is named with 'global' in it. !

UT3Board subclass: #UT3BasicBoard
	instanceVariableNames: 'cellMatrix isFull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3BasicBoard commentStamp: '<historical>' prior: 0!
An UT3BasicBoard is a basic Tic Tac Toe board.
With it, you can play a normal 3 x 3 Tic Tac Toe game.

Instance Variables
	cellMatrix:		<Object>
	isFull:		<Object>
	movesCount:		<Object>
	size:		<Object>
	winner:		<Object>

cellMatrix
	- xxxxx

isFull
	- xxxxx

movesCount
	- xxxxx

size
	- xxxxx

winner
	- xxxxx
!

!UT3BasicBoard class methodsFor: 'as yet unclassified' stamp: 'ShineLow 7/4/2013 17:04'!
newWithSize: anInteger
	^ self new resetWithSize: anInteger! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:26'!
= aBasicBoard
	^ winner = aBasicBoard winner! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/6/2013 12:54'!
atRow: aRow column: aColumn
	^ cellMatrix at: aRow at: aColumn! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 14:29'!
atRow: aRow column: aColumn put: aSymbol 
	| cell |
	self isFull ifTrue: [ MoveError signal: 'Board is full.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	cell := cellMatrix at: aRow at: aColumn.
	cell state = #empty ifFalse: [ MoveError signal: 'Cell already filled.' ].
	( aSymbol = #circle ) ifTrue: [ cell setCircle ] ifFalse: [ cell setCross ].
	movesCount := movesCount + 1.
	"Every time we make a move, we check to see if a winner is already decided"
	self checkWinnerAtRow: aRow column: aColumn matrix: cellMatrix.
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/8/2013 00:51'!
canMoveAtRow: aRow column: aColumn
	^ (cellMatrix at: aRow at: aColumn) isEmpty! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 14:27'!
hash
	^ winner hash! !

!UT3BasicBoard methodsFor: 'public' stamp: 'JonathanOsting 7/6/2013 05:13'!
indicesDo: aBlock
	cellMatrix transposed.
	cellMatrix indicesDo: aBlock.! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 11:12'!
initialize
	size := 3. "Default board size is 3x3"
	cellMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 11:20'!
isFull
	^ movesCount = ( size * size )! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 12:28'!
movesCount
	^ movesCount! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'Oliver 7/5/2013 21:14'!
printBoardOn: aStream
	cellMatrix transposed.
	
	cellMatrix indicesDo: [
		:row :column | 
		
		(cellMatrix at: row at: column) printStateOn: aStream.
		column = size
		ifTrue: [ aStream nextPutAll: '|'. aStream cr ] 
		ifFalse: [ aStream nextPutAll: '|' ]
		].
	! !

!UT3BasicBoard methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 16:52'!
printRow: aRow on: aStream
	(cellMatrix atRow: aRow) do: [ :cell | cell printStateOn: aStream ]
							     separatedBy: [ aStream nextPutAll: '|'  ]! !

!UT3BasicBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:03'!
resetWithSize: anInteger
	size := anInteger.
	cellMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3Cell new ].
	movesCount := 0.
	winner := #undecided.! !

!UT3BasicBoard methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:23'!
state
	^ winner! !

!UT3BasicBoard methodsFor: 'public' stamp: 'ShineLow 7/4/2013 11:20'!
winner
	^ winner! !

UT3BasicBoard subclass: #UT3RecursiveNestedBoard
	instanceVariableNames: 'boardMatrix movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3RecursiveNestedBoard commentStamp: '<historical>' prior: 0!
An UT3RecursiveNestedBoard is xxxxxxxxx.

Instance Variables
	boardMatrix:		<Object>
	movesList:		<Object>

boardMatrix
	- xxxxx

movesList
	- xxxxx
!

UT3RecursiveNestedBoard subclass: #UT3DoubleNestedBoard
	instanceVariableNames: 'boardMatrix movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3DoubleNestedBoard commentStamp: '<historical>' prior: 0!
An UT3DoubleNestedBoard is xxxxxxxxx.

Instance Variables
	boardMatrix:		<Object>
	movesList:		<Object>

boardMatrix
	- xxxxx

movesList
	- xxxxx
!

!UT3DoubleNestedBoard methodsFor: 'action' stamp: 'ShineLow 7/8/2013 00:51'!
at: anArray subBoard: subArray ssubBoard: ssubArray put: aSymbol
	
	|row column subRow subColumn subBoard|	
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	row := anArray first.
	column := anArray second.
	subRow := subArray first.
	subColumn := subArray second.
	subBoard := boardMatrix at: row at: column.
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(subBoard canMoveAtRow: subRow column: subColumn) ifFalse: [ MoveError signal: 'Subboard cell filled' ].
	subBoard at: subArray subBoard: ssubArray put: aSymbol.
	! !

!UT3DoubleNestedBoard methodsFor: 'action' stamp: 'Oliver 7/5/2013 21:53'!
canMoveAt: anArray subBoard: subArray ssubBoard: ssubArray
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."
	| row column lastMove expectedArray |
	"init"
	row := anArray first.
	column := anArray second.
	
	(movesList size = 0) ifTrue: [ ^ true ].
	lastMove := movesList last.
	expectedArray := lastMove second.
	( anArray = expectedArray )
	ifTrue: [ ^ (boardMatrix at: row at: column) canMoveAt: subArray subBoard: ssubArray ]
	ifFalse: [ (boardMatrix at: expectedArray first at: expectedArray second) isFull
			  ifTrue: [ ^ (boardMatrix at: row at: column) canMoveAt: subArray subBoard: ssubArray ] ].
	^ false! !

!UT3DoubleNestedBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/5/2013 20:09'!
initialize
	size := 3. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3RecursiveNestedBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3DoubleNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:05'!
isFull
	boardMatrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3DoubleNestedBoard methodsFor: 'printing' stamp: 'Oliver 7/5/2013 21:11'!
printBoardOn: aStream
	
	|subBoardSize|
	subBoardSize := (boardMatrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(boardMatrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream cr.  ].
			aStream cr.
		].
		aStream cr.
	].

! !

!UT3DoubleNestedBoard methodsFor: 'printing' stamp: 'Oliver 7/5/2013 20:28'!
printRow: aRow on: aStream
	boardMatrix do: [ :subBoard | subBoard printRow: aRow on: aStream ].! !

!UT3DoubleNestedBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/5/2013 20:22'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3RecursiveNestedBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3DoubleNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:05'!
winner
	^ winner! !

!UT3RecursiveNestedBoard methodsFor: 'action' stamp: 'ShineLow 7/8/2013 00:51'!
at: anArray subBoard: subArray put: aSymbol
	|row column subRow subColumn subBoard|
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	row := anArray first.
	column := anArray second.
	subRow := subArray first.
	subColumn := subArray second.
	subBoard := boardMatrix at: row at: column.
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(subBoard canMoveAtRow: subRow column: subColumn) ifFalse: [ MoveError signal: 'Subboard cell filled' ].
	
	subBoard atRow: subRow column: subColumn put: aSymbol.
	movesCount := movesCount + 1.
	movesList add: { anArray. subArray }.
	"Every time we make a move, we check to see if a winner is already decided"	
	( (subBoard winner = #cross) | (subBoard winner = #circle) ) ifTrue: [ 
		self checkWinnerAtRow: row column: column matrix: boardMatrix ].
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]
	! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:19'!
atRow: aRow column: aColumn
	^ cellMatrix at: aRow at: aColumn! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:19'!
atRow: aRow column: aColumn put: aSymbol 
	| cell |
	self isFull ifTrue: [ MoveError signal: 'Board is full.' ].
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	cell := cellMatrix at: aRow at: aColumn.
	cell state = #empty ifFalse: [ MoveError signal: 'Cell already filled.' ].
	( aSymbol = #circle ) ifTrue: [ cell setCircle ] ifFalse: [ cell setCross ].
	movesCount := movesCount + 1.
	"Every time we make a move, we check to see if a winner is already decided"
	self checkWinnerAtRow: aRow column: aColumn matrix: cellMatrix.
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]! !

!UT3RecursiveNestedBoard methodsFor: 'action' stamp: 'ShineLow 7/8/2013 00:51'!
canMoveAt: anArray subBoard: subArray 
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."
	| row column subRow subColumn lastMove expectedArray |
	row := anArray first.
	column := anArray second.
	subRow := subArray first.
	subColumn := subArray second.
	(movesList size = 0) ifTrue: [ ^ true ].
	lastMove := movesList last.
	expectedArray := lastMove second.
	( anArray = expectedArray )
	ifTrue: [ ^ (boardMatrix at: row at: column) canMoveAtRow: subRow column: subColumn ]
	ifFalse: [ (boardMatrix at: expectedArray first at: expectedArray second) isFull
			  ifTrue: [ ^ (boardMatrix at: row at: column) canMoveAtRow: subRow column: subColumn ] ].
	^ false! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'ShineLow 7/8/2013 00:51'!
canMoveAtRow: aRow column: aColumn
	^ (cellMatrix at: aRow at: aColumn) state = #empty! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/6/2013 06:31'!
indicesDo: aBlock
	boardMatrix indicesDo: aBlock.! !

!UT3RecursiveNestedBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/5/2013 20:30'!
initialize
	size := 3. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:08'!
isFull
	boardMatrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:31'!
printBoardOn: aStream
	|subBoardSize|
	subBoardSize := (boardMatrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(boardMatrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			aStream cr.
		].
		aStream cr.
	].! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 21:12'!
printRow: aRow on: aStream

	|subBoardSize|
	subBoardSize := (boardMatrix at: 1 at: 1) size.
	aStream nextPutAll: ' ||| '.
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(boardMatrix at: aRow at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			 aStream nextPutAll: ' ||| '.
		].

	"boardMatrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	(cellMatrix atRow: aRow) do: [ :cell | cell printStateOn: aStream ]
							     separatedBy: [ aStream nextPutAll: '|'  ]"! !

!UT3RecursiveNestedBoard methodsFor: 'initialize-release' stamp: 'Oliver 7/5/2013 20:31'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3RecursiveNestedBoard methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 20:31'!
winner
	^ winner! !

!UT3Board methodsFor: 'action' stamp: 'ShineLow 7/4/2013 18:12'!
at: anArray subBoard: subArray put: aSymbol
	^ self subclassResponsibility ! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:29'!
checkWinnerAtRow: aRow column: aColumn matrix: aMatrix
	|currentWinner diagonalSet|
	winner = #undecided ifFalse: [ ^nil ].
	"Check current row"
	currentWinner := self getWinnerAtSet: ( (aMatrix atRow: aRow) asSet ).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Check current column"
	currentWinner := self getWinnerAtSet: ( ( aMatrix atColumn: aColumn ) asSet).
	currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ].
	"Check diagonals, from top left to bottom right"
	diagonalSet := Set new.
	aRow = aColumn ifTrue:[
		1 to: size do: [ :index | diagonalSet add: ( aMatrix at: index at: index ) ].
		currentWinner := self getWinnerAtSet: diagonalSet.
		currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ]
		].
	"From bottom left to top right"
	diagonalSet := Set new.
	aRow = ( size - aColumn + 1 ) ifTrue: [ 
		1 to: size do: [ :index | diagonalSet add: ( aMatrix at: index at: ( size - index + 1 ) ) ]	.
		currentWinner := self getWinnerAtSet: diagonalSet.
		currentWinner = #none ifFalse: [ winner := currentWinner. ^nil ]
	]! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 14:25'!
getWinnerAtSet: aSet
	|winnerCell|
	(aSet size = 1) ifFalse: [ ^#none ].
	winnerCell := aSet atRandom.
	(winnerCell state = #empty | winnerCell state = #undecided) ifTrue: [ ^#none ] ifFalse: [ ^ winnerCell state ]! !

!UT3Board methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:09'!
initialize 
	^ self subclassResponsibility! !

!UT3Board methodsFor: 'action' stamp: 'ShineLow 7/4/2013 18:12'!
player: aPlayer moveRow: aMoveRow moveCol: aMoveCol
	|symbol row column subRow subColumn|
	aPlayer = 1 ifTrue: [ symbol := #circle ] ifFalse: [ symbol := #cross ].
	row := (aMoveRow / size) asFraction ceiling.
	column := ( aMoveCol / size ) asFraction ceiling.
	subRow := aMoveRow % size.
	(subRow = 0) ifTrue: [ subRow := size ].
	subColumn := aMoveCol % size.
	( subColumn = 0 ) ifTrue: [ subColumn := size ].
	self at: { row. column } subBoard: { subRow. subColumn } put: symbol! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 14:39'!
printBoardOn: aStream
	^ self subclassResponsibility ! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 14:39'!
printBoardString
	|stream|
	stream := WriteStream on: ( String new ).
	self printBoardOn: stream.
	^ stream contents! !

!UT3Board methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 16:57'!
printOn: aStream
	" prints the gameboard on a stream"
	self printBoardOn: aStream! !

!UT3Board methodsFor: 'private' stamp: 'ShineLow 7/4/2013 17:15'!
size
	^ size! !

UT3Board subclass: #UT3NestedBoard
	instanceVariableNames: 'boardMatrix movesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3NestedBoard commentStamp: '<historical>' prior: 0!
An UT3NestedBoard is a TicTacToe Board that implements the Ultimate Tic Tac Toe game. It holds a matrix of regular TicTacToe boards, and each move will need to specify column and row of both the larger board and smaller board.

Instance Variables
	boardMatrix:		<Object>

boardMatrix
	- xxxxx
!

!UT3NestedBoard methodsFor: 'accessing' stamp: 'JonathanOsting 7/6/2013 06:58'!
at: aRow at: aColumn
	^ boardMatrix at: aRow at: aColumn! !

!UT3NestedBoard methodsFor: 'action' stamp: 'ShineLow 7/8/2013 00:51'!
at: anArray subBoard: subArray put: aSymbol
	|row column subRow subColumn subBoard|
	(aSymbol = #circle) | (aSymbol = #cross) ifFalse: [ MoveError signal: 'Unknown move symbol.' ].
	row := anArray first.
	column := anArray second.
	subRow := subArray first.
	subColumn := subArray second.
	subBoard := boardMatrix at: row at: column.
	subBoard isFull ifTrue: [ MoveError signal: 'Subboard already full' ].
	(subBoard canMoveAtRow: subRow column: subColumn) ifFalse: [ MoveError signal: 'Subboard cell filled' ].
	
	subBoard atRow: subRow column: subColumn put: aSymbol.
	movesCount := movesCount + 1.
	movesList add: { anArray. subArray }.
	"Every time we make a move, we check to see if a winner is already decided"	
	( (subBoard winner = #cross) | (subBoard winner = #circle) ) ifTrue: [ 
		self checkWinnerAtRow: row column: column matrix: boardMatrix ].
	"If this is the last move, and we still don't have a winner, set winner as none"
	(self isFull) & (winner = #undecided) ifTrue: [ winner := #none ]
	! !

!UT3NestedBoard methodsFor: 'action' stamp: 'ShineLow 7/8/2013 01:13'!
canMoveAt: anArray
	| row column lastMove expectedArray |
	row := anArray first.
	column := anArray second.
	(movesList size = 0) ifTrue: [ ^ ( (row <= size) & (column <= size) ) ].
	lastMove := movesList last.
	expectedArray := lastMove second.
	( anArray = expectedArray )
	ifTrue: [ ^ true ]
	ifFalse: [ (boardMatrix at: expectedArray first at: expectedArray second) isFull
			  ifTrue: [ ^ true ] ].
	^ false! !

!UT3NestedBoard methodsFor: 'action' stamp: 'ShineLow 7/8/2013 01:12'!
canMoveAt: anArray subBoard: subArray 
	"A move is valid if only the current coordinate is the same as the previous subArray coordinate.
	If the target board is already full, then the move is valid at any location."
	|row column subRow subColumn|
	row := anArray first. column := anArray second.
	subRow := subArray first. subColumn := subArray second.
	(self canMoveAt: anArray)
	ifTrue: [ ^ (boardMatrix at: row at: column) canMoveAtRow: subRow column: subColumn ].
	^ false! !

!UT3NestedBoard methodsFor: 'enumerating' stamp: 'JonathanOsting 7/6/2013 06:41'!
indicesDo: aBlock
	boardMatrix indicesDo: aBlock.! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 13:25'!
initialize
	size := 3. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard new ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 14:50'!
isFull
	boardMatrix do: [ :subBoard | subBoard isFull ifFalse: [ ^false ] ].
	^ true! !

!UT3NestedBoard methodsFor: 'printing' stamp: 'Oliver 7/5/2013 21:15'!
printBoardOn: aStream
	|subBoardSize|
	subBoardSize := (boardMatrix at: 1 at: 1) size.
	(1 to: size) do: [ :row |
		(1 to: subBoardSize) do: [ :subRow |
			(1 to: size) do: [ :column |
				(boardMatrix at: row at: column) printRow: subRow on: aStream. ]
					    separatedBy: [ aStream nextPutAll: ' || '  ].
			aStream nextPutAll: ' || '.
			aStream cr.
		].
		aStream cr.
	].! !

!UT3NestedBoard methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 17:08'!
resetWithSize: anInteger
	size := anInteger. "Default board size is 3x3"
	boardMatrix := Matrix rows: size columns: size tabulate: [ :unused_i :unused_j | UT3BasicBoard newWithSize: anInteger ].
	movesList := LinkedList new.
	movesCount := 0.
	winner := #undecided.! !

!UT3NestedBoard methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 14:44'!
winner
	^ winner! !

Object subclass: #UT3Cell
	instanceVariableNames: 'state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3Cell commentStamp: '<historical>' prior: 0!
An UT3Cell is class representing a Cell in a Board.

Instance Variables
	state:		<Object>

state
	- xxxxx
!

!UT3Cell methodsFor: 'comparing' stamp: 'ShineLow 7/4/2013 11:23'!
= aCell
	^ state = aCell state! !

!UT3Cell methodsFor: 'comparing' stamp: 'ShineLow 7/4/2013 12:16'!
hash
	^ state hash! !

!UT3Cell methodsFor: 'initialize-release' stamp: 'ShineLow 7/4/2013 10:18'!
initialize
	state := #empty! !

!UT3Cell methodsFor: 'accessing' stamp: 'JonathanOsting 7/6/2013 07:30'!
isEmpty
	^ state = #empty! !

!UT3Cell methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 10:26'!
printOn: aStream
	aStream nextPutAll: 'Cell with '.
	state = #empty ifTrue: [ aStream nextPutAll: 'nothing' ]
					 ifFalse: [ state = #circle ifTrue: [ aStream nextPutAll: 'O' ]
											  ifFalse: [ aStream nextPutAll: 'X' ] ]! !

!UT3Cell methodsFor: 'printing' stamp: 'Oliver 7/5/2013 19:49'!
printStateOn: aStream 
		state = #empty ifTrue: [ aStream nextPutAll: ' _ ' ]
					 ifFalse: [ state = #circle ifTrue: [ aStream nextPutAll: ' 0 ' ]
											  ifFalse: [ aStream nextPutAll: ' x ' ] ]! !

!UT3Cell methodsFor: 'printing' stamp: 'JonathanOsting 7/6/2013 06:15'!
printString
	" return a string representing the cell"
	state = #empty ifTrue: [ ^ ' _ ' ]
					 ifFalse: [ state = #circle ifTrue: [ ^ ' 0 ' ]
											  ifFalse: [ ^ ' x ' ] ]! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:24'!
setCircle
	state = #empty ifFalse: [ MoveError signal ].
	state := #circle! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:25'!
setCross
	state = #empty ifFalse: [ MoveError signal ].
	state := #cross! !

!UT3Cell methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 10:22'!
state
	^ state! !

Object subclass: #UT3System
	instanceVariableNames: 'board currentPlayer gameTypes currentGameType ai'
	classVariableNames: 'MaxPlayers PlayerIcons'
	poolDictionaries: ''
	category: 'CS528-UT3Base'!

!UT3System commentStamp: '<historical>' prior: 0!
An UT3System is the class encapsulating an entire Ultimate TicTacToe game.

It contains an interface to make moves for each player, and holds an instance of UT3Board that represents the game board state, and is stateful in the sense that it records each player's move.

You can use the provided API to get the which player's turn it is, etc. Invalid moves will throw MoveError.

Instance Variables
!

!UT3System class methodsFor: 'class initialization' stamp: 'ShineLow 7/4/2013 18:55'!
initialize 
	super initialize.
	MaxPlayers := 2.
	PlayerIcons := Dictionary newFrom: { 1->#circle. 2->#cross }! !

!UT3System class methodsFor: 'instance creation' stamp: 'ShineLow 7/4/2013 19:12'!
new
	MaxPlayers isNil ifTrue: [ self initialize ].
	^ self basicNew initialize.! !

!UT3System methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 19:55'!
board
	^board.! !

!UT3System methodsFor: 'accessing' stamp: 'Oliver 7/5/2013 19:56'!
board: aBoard
	board := aBoard.! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 19:00'!
currentGameType
	^ currentGameType! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 20:18'!
currentGameType: aGameType
	self resetWithGameType: aGameType asSymbol! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 19:00'!
currentPlayer
	^ currentPlayer! !

!UT3System methodsFor: 'accessing' stamp: 'ShineLow 7/4/2013 19:00'!
gameTypes
	^ gameTypes! !

!UT3System methodsFor: 'initialize-release' stamp: 'ShineLow 7/8/2013 01:42'!
initialize
	board := UT3BasicBoard new.
	currentPlayer := 1.
	gameTypes := { #basic. #ultimate. #double_ultimate }.
	currentGameType := #basic.
	ai := nil.! !

!UT3System methodsFor: 'actions' stamp: 'ShineLow 7/8/2013 01:51'!
player: aPlayer moveAt: anArray subBoard: anArray2
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	currentGameType = #ultimate ifFalse: [ SystemError signal: 'Only ultimate gametype supports this move!!' ].
	(board canMoveAt: anArray subBoard: anArray2)
	ifTrue: [ board at: anArray subBoard: anArray2 put: (PlayerIcons at: currentPlayer).
   			 currentPlayer := currentPlayer % MaxPlayers + 1 ]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].
	
	(ai = nil) ifFalse: [ ai move. currentPlayer := currentPlayer % MaxPlayers + 1 ]! !

!UT3System methodsFor: 'actions' stamp: 'Oliver 7/5/2013 21:39'!
player: aPlayer moveAt: anArray subBoard: anArray2 ssubBoard: anArray3
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	currentGameType = #double_ultimate ifFalse: [ SystemError signal: 'Only double_ultimate gametype supports this move!!' ].
	(board canMoveAt: anArray subBoard: anArray2 ssubBoard: anArray3)
	ifTrue: [ board at: anArray subBoard: anArray2 ssubBoard: anArray3 put: (PlayerIcons at: currentPlayer).
   			 currentPlayer := currentPlayer % MaxPlayers + 1 ]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].! !

!UT3System methodsFor: 'actions' stamp: 'ShineLow 7/8/2013 01:51'!
player: aPlayer moveRow: aRow column: aColumn 
	currentPlayer = aPlayer ifFalse: [ SystemError signal: 'Not this players turn' ].
	currentGameType = #basic ifFalse: [ SystemError signal: 'Only basic gametype supports this move!!' ].
	(board canMoveAtRow: aRow column: aColumn)
	ifTrue: [ board atRow: aRow column: aColumn put: ( PlayerIcons at: currentPlayer ).
          		 currentPlayer := currentPlayer % MaxPlayers + 1]
	ifFalse: [ SystemError signal: 'Cannot move there!!' ].
	
	(ai = nil) ifFalse: [ ai move. currentPlayer := currentPlayer % MaxPlayers + 1 ]! !

!UT3System methodsFor: 'printing' stamp: 'ShineLow 7/4/2013 20:44'!
printOn: aStream 
	aStream nextPutAll: 'Current Game Type: '.
	currentGameType printOn: aStream.
	aStream cr; nextPutAll: 'Current player: '.
	currentPlayer printOn: aStream.
	aStream cr; nextPutAll: 'Current board state: '.
	board winner printOn: aStream.
	aStream cr. board printBoardOn: aStream.! !

!UT3System methodsFor: 'actions' stamp: 'Oliver 7/5/2013 20:09'!
resetWithGameType: aSymbol
	(gameTypes includes: aSymbol) ifFalse: [ SystemError signal: 'Unknown game type' ].
	aSymbol = #basic ifTrue: [ self initialize ].
	aSymbol = #ultimate ifTrue: [ self initialize. board := UT3NestedBoard new. currentGameType := #ultimate ].
	aSymbol = #double_ultimate ifTrue: [ self initialize. board := UT3DoubleNestedBoard new. currentGameType := #double_ultimate ].
! !

!UT3System methodsFor: 'actions' stamp: 'ShineLow 7/8/2013 01:49'!
resetWithGameType: aSymbol ai: anAiSymbol
	(gameTypes includes: aSymbol) ifFalse: [ SystemError signal: 'Unknown game type' ].
	aSymbol = #basic ifTrue: [ 
		self initialize. 
		anAiSymbol = #random ifTrue: [ ai := UT3RandomAI newWith: board as: (PlayerIcons at: 2) ] ].
	aSymbol = #ultimate ifTrue: [
		self initialize.
		board := UT3NestedBoard new.
		currentGameType := #ultimate.
		anAiSymbol = #random ifTrue: [ ai := UT3NestedRandomAI newWith: board as: ( PlayerIcons at: 2 ) ] ].
	aSymbol = #double_ultimate ifTrue: [ self initialize. board := UT3DoubleNestedBoard new. currentGameType := #double_ultimate ].
! !
UT3System initialize!
